   MEMBER()

   INCLUDE('mtDeepAssign.inc'),ONCE
   
   MAP
   END

!-------------------------------------------------------------------------------
MTDeepAssignClass.construct            procedure
!-------------------------------------------------------------------------------
  code
  self.sourceFile &= null
  self.sourceRec  &= null
  self.TargetFile &= null
  self.TargetRec  &= null
  self.matchfieldQ &= new type:matchfieldQ
  return
!-------------------------------------------------------------------------------
MTDeepAssignClass.destruct            procedure
!-------------------------------------------------------------------------------
ndx     long,auto
  code
  if self.matchfieldQ
    loop ndx = 1 to records(self.matchfieldQ)
      get(self.matchfieldQ,ndx)
      self.matchfieldQ.sourceany &= null
      self.matchfieldQ.targetany &= null
    end
    free(self.matchfieldQ)
    dispose(self.matchfieldQ)
  end
  return
!-------------------------------------------------------------------------------
MTDeepAssignClass.assign              procedure
!-------------------------------------------------------------------------------
ndx     long,auto
  code
  loop ndx = 1 to records(self.matchfieldQ)
    get(self.matchfieldQ,ndx)   
    self.matchfieldQ.targetany = self.matchfieldQ.sourceany
  end
  return
!-------------------------------------------------------------------------------
MTDeepAssignClass.stripPrefix         procedure(string pName) !,string,private
!-------------------------------------------------------------------------------
ret   cstring(50),auto
pos   long,auto
  code
  pos = instring(':',pName,1,1)
  if pos
    ret = upper(clip(sub(pName,pos+1,len(pName)-pos)))
  else
    ret = upper(clip(pName))
  end
  return(ret)
!-------------------------------------------------------------------------------
MTDeepAssignClass.init                procedure(file pSource, file pTarget)
!-------------------------------------------------------------------------------
sourcendx           long
sourcename          cstring(50)
targetndx           long
targetname          cstring(50)
  code
  self.destruct()
  self.construct()
  self.sourceFile    &= pSource
  self.TargetFile    &= pTarget
  self.sourceRec     &= pSource{prop:record}
  self.targetRec     &= pTarget{prop:record}
  self.SourceFields  = pSource{prop:fields}
  self.targetFields  = pTarget{prop:fields}
  loop targetndx = 1 to self.TargetFields
    targetname = self.stripPrefix(WHO(self.targetRec, targetndx))
    loop sourcendx = 1 to self.SourceFields
      sourcename = self.stripPrefix(WHO(self.sourceRec, sourcendx))
      IF sourcename = targetname
        clear(self.matchfieldQ)
        self.matchfieldQ.sourceany &= null
        self.matchfieldQ.targetany &= null
        self.matchfieldQ.sourceNdx   = sourcendx
        self.matchfieldQ.sourcename  = sourcename
        self.matchfieldQ.sourceAny   &= what(self.sourceRec, sourcendx)
        self.matchfieldQ.targetNdx   = targetndx
        self.matchfieldQ.targetname  = targetname
        self.matchfieldQ.targetAny   &= what(self.targetRec, targetndx)
        add(self.matchfieldQ)
        break
      end
    end !sourcendx
  end !targetndx
  return
!-------------------------------------------------------------------------------
